-- Put functions in this file to use them in several other scripts.
-- To get access to the functions, you need to put:
-- require "my_directory.my_file"
-- in any script using the functions.
local M = {}
M.__index = M

--Adapted from programming in lua book
function M.runMain(size)
	N = size -- board size   

	function solutionToStr(a)  
		local outer = {}
		for i = 1, N do -- for each row  
			local inner = {}
			for j = 1, N do -- and for each column  
				-- write "X" or "-" plus a space  
				local value = a[i] == j and "X" or "-"
				table.insert(inner, value .. " ")  
			end  
			local str_inner = table.concat(inner, " ")
			table.insert(outer, str_inner)  
		end  
		return table.concat(outer, "\n")
	end
	
	-- check whether position (n,c) is free from attacks  
	function isplaceok (a, n, c)  
		for i = 1, n - 1 do -- for each queen already placed  
			if (a[i] == c) or -- same column?
				(a[i] - i == c - n) or -- same diagonal?
				(a[i] + i == c + n) then -- same diagonal?
					return false -- place can be attacked  
			end  
		end  
		return true -- no attacks; place is OK  
	end   -- print a board  
	
	-- add to board 'a' all queens from 'n' to 'N'  
	function addqueen (a, n)  
		if n > N then -- all queens have been placed?
			return
		else -- try to place n-th queen  
			for c = 1, N do  
				if isplaceok(a, n, c) then  
					a[n] = c -- place n-th queen at column 'c'  
					addqueen(a, n + 1)  
				end  
			end  
		end  
	end  
	-- run the program
	local solution = {}
	addqueen(solution, 1)
	return solutionToStr(solution)
end

--Duplication, yeah
function M.getChunk()
	return [[
	function work(size)
		N = tonumber(size) -- board size   

		function solutionToStr(a)  
			local outer = {}
			for i = 1, N do -- for each row  
				local inner = {}
				for j = 1, N do -- and for each column  
					-- write "X" or "-" plus a space  
					local value = a[i] == j and "X" or "-"
					table.insert(inner, value .. " ")  
				end  
				local str_inner = table.concat(inner, " ")
				table.insert(outer, str_inner)  
			end  
			return table.concat(outer, "\n")
		end

		-- check whether position (n,c) is free from attacks  
		function isplaceok (a, n, c)  
			for i = 1, n - 1 do -- for each queen already placed  
				if (a[i] == c) or -- same column?
				(a[i] - i == c - n) or -- same diagonal?
				(a[i] + i == c + n) then -- same diagonal?
					return false -- place can be attacked  
				end  
			end  
			return true -- no attacks; place is OK  
		end   -- print a board  

		-- add to board 'a' all queens from 'n' to 'N'  
		function addqueen (a, n)  
			if n > N then -- all queens have been placed?
				return
			else -- try to place n-th queen  
				for c = 1, N do  
					if isplaceok(a, n, c) then  
						a[n] = c -- place n-th queen at column 'c'  
						addqueen(a, n + 1)  
					end  
				end  
			end  
		end  
		-- run the program
		local solution = {}
		addqueen(solution, 1)
		return solutionToStr(solution)
	end
	]]
end

return M